import React, { Component, PropTypes } from 'react';
import ReactDOM from 'react-dom';
import {
  createStore,
  combineReducers,
  applyMiddleware
} from 'redux';
import { connect, Provider } from 'react-redux';
import {
  Form,
  Control,
  actions,
  combineForms,
} from 'react-redux-form';
import thunk from 'redux-thunk';
import createLogger from 'redux-logger';

const store = createStore(combineForms({
  user: {
    nest: {
      name: 'initial name',
      email: 'initial email',
    },
  },
}), applyMiddleware(thunk, createLogger()));

class App extends Component {
  componentDidMount() {
    store.dispatch(actions.load('user', { nest: { name: 'loaded name', email: 'loaded email' } }))
  }
  handleSubmit(vals) {
    console.log(vals);
  }
  handleReset() {
    store.dispatch(actions.reset('user'))
  }
  render() {
    return (
      <Form
        model="user"
        onSubmit={(vals) => this.handleSubmit(vals)}
      >
        <label>Name:</label>
        <Control.text model=".nest.name" />
        <br />

        <label>Email:</label>
        <Control.text type="email" model=".nest.email" />
        <br />

        <button>Submit!</button>
        <button onClick={ this.handleReset }>Reset!</button>
      </Form>
    );
  }
}

ReactDOM.render(
  <Provider store={store}>
    <App />
  </Provider>
, document.querySelector('#app'));
